﻿﻿﻿require({
    cache: {
        'url:epi-cms/asset/templates/HierarchicalList.html': "﻿<div class=\"epi-hierarchicalList\">\n    <div class=\"epi-gadgetInnerToolbar\" data-dojo-attach-point=\"searchBoxNode\">\n        <div data-dojo-attach-point=\"searchBox\"\n             data-dojo-type=\"epi/shell/widget/SearchBox\"\n             data-dojo-props=\"triggerContextChange: this.triggerContextChange, triggerChangeOnEnter: true, encodeSearchText: true\">\n        </div>\n    </div>\n    <div data-dojo-attach-point=\"container\"\n         data-dojo-type=\"dijit/layout/BorderContainer\"\n         data-dojo-props=\"gutters: false\">\n\n        <div data-dojo-attach-point=\"contentNode\">\n            <div class=\"epi-secondaryGadgetContainer epi-gadgetTopContainer\"\n                 data-dojo-attach-point=\"tree\"\n                 data-dojo-type=\"epi-cms/widget/FolderTree\"\n                 data-dojo-props=\"region:'center', splitter:false, model: this.model.treeStoreModel, showRoot: false, contextMenu: this.contextMenu, dndSource: this.dndSource\"></div>\n            <div class=\"epi-gadgetBottomContainer\"\n                 data-dojo-attach-point=\"listContainer\"\n                 data-dojo-type=\"dijit/layout/BorderContainer\"\n                 data-dojo-props=\"region:'bottom', splitter:true, gutters: false\">\n                <div class=\"epi-createContentContainer\"\n                     data-dojo-attach-point=\"createContentArea\"\n                     data-dojo-type=\"dijit/layout/_LayoutWidget\"\n                     data-dojo-props=\"region:'top', splitter:false\">\n                    <button type=\"button\" class=\"epi-flat epi-chromeless\"\n                            data-dojo-type=\"dijit/form/Button\"\n                            data-dojo-attach-point=\"createContentAreaButton\"></button>\n                </div>\n                <div data-dojo-attach-point=\"list\"\n                     data-dojo-type=\"epi-cms/widget/ContentList\"\n                     data-dojo-props=\"region:'center', splitter:false, store: this.model.store, queryOptions: this.model.listQueryOptions, contextMenu: this.contextMenu, resources: this.res\">\n                </div>\n            </div>\n        </div>\n        <div data-dojo-attach-point=\"resultNode\" style=\"display:none\">\n            <div data-dojo-attach-point=\"searchResultList\"\n                 data-dojo-type=\"epi-cms/widget/ContentList\"\n                 data-dojo-props=\"region:'center', splitter:false, store: this.model.searchStore, queryOptions: this.model.searchResultQueryOptions, contextMenu: this.contextMenu, resources: this.res\">\n            </div>\n        </div>\n    </div>\n</div>\n"
    }
});
﻿define("gl-translations/asset/HierarchicalList", [
    // dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-class",
    "dojo/dom-geometry",
    "dojo/dom-style",
    "dojo/keys",
    "dojo/on",
    "dojo/when",

    // dijit
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/layout/_LayoutWidget",
    "dijit/layout/BorderContainer", // Used in template

    // dojox
    "dojox/html/entities",

    // epi
    "epi/string",
    "epi/shell/command/_WidgetCommandBinderMixin",
    "epi/shell/widget/_ModelBindingMixin",
    "epi/shell/DestroyableByKey",
    "epi/shell/widget/dialog/Alert",

    "epi/shell/widget/ContextMenu",
    "epi-cms/widget/FolderTree",
    "epi-cms/widget/ContentList",
    "./view-model/HierarchicalListViewModel",
    "epi/shell/dnd/tree/multiDndSource",

    // template
    "dojo/text!./templates/HierarchicalList.html",

    // Resources
    "epi/i18n!epi/cms/nls/episerver.cms.widget.hierachicallist"
],

    function (
        // dojo
        array,
        declare,
        lang,
        aspect,
        domClass,
        domGeometry,
        domStyle,
        keys,
        on,
        when,

        // dijit
        _TemplatedMixin,
        _WidgetsInTemplateMixin,
        _LayoutWidget,
        BorderContainer,

        //dojox
        htmlEntities,

        // epi
        epistring,

        _WidgetCommandBinderMixin,
        _ModelBindingMixin,
        DestroyableByKey,
        Alert,

        ContextMenu,
        FolderTree,
        ContentList,
        HierarchicalListViewModel,
        multiDndSource,

        // template
        template,

        // Resources
        res
    ) {

        return declare([_LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ModelBindingMixin, _WidgetCommandBinderMixin, DestroyableByKey], {
            // summary:
            //      Base widget for displaying the panel with tree on top and list for displaying leaf's items, as well as the search box on very top.
            // tags:
            //      internal abstract

            contextMenu: null,

            templateString: template,

            showRoot: false,

            // showThumbnail: [public] Boolean
            //      Flag to indicate this widget allowed to show a thumbnail in the list.
            showThumbnail: false,


            triggerContextChange: true,

            res: res,

            modelClassName: HierarchicalListViewModel,

            // hierarchicalListClass: [readonly] String
            //      The CSS class to be used on the hierarchical list.
            hierarchicalListClass: "",

            // noDataMessages: [public] Object
            //      Object containing the texts for when the list contains no items. It should have two properties named single and multiple.
            noDataMessages: null,

            // noSearchResultMessage: [public] String
            //      No search result message for search result list.
            noSearchResultMessage: res.nosearchresults,

            // dndSource: [public] multiDndSource
            //      The dnd source to use for the tree
            dndSource: multiDndSource,

            modelBindingMap: {
                listQuery: ["listQuery"],
                treePaths: ["treePaths"],
                selectedListItems: ["selectedListItems"],
                searchListQuery: ["searchListQuery"],
                noDataMessage: ["noDataMessage"]
            },

            _setSelectedListItemsAttr: function (value) {
                this.list.grid.clearSelection();
                (value || []).forEach(function (selectedItem) {
                    this.list.grid.select(selectedItem.contentLink);
                }, this);
                this._set("selectedListItems", value);
            },

            _setListQueryAttr: function (value) {
                this.list.set("query", value);
            },

            _setNoDataMessageAttr: function (value) {
                this.list.set("noDataMessage", value);
            },

            _setTreePathsAttr: function (value) {
                // this.tree.set("paths", value);
            },

            _setShowRootAttr: function (value) {
                // this.tree.set("showRoot", value);
            },

            postMixInProperties: function () {
                this.inherited(arguments);

                if (!this.model && !this.commandProvider && this.modelClassName) {
                    var modelClass = declare(this.modelClassName);
                    this.model = this.commandProvider = new modelClass({
                        componentId: this.componentId,
                        repositoryKey: this.repositoryKey,
                        noDataMessages: this.noDataMessages
                    });
                }

                this.setupContextMenu();
            },

            setupContextMenu: function () {
                // summary: set up the context menu
                //
                // tags:
                //      public
                this.own(this.contextMenu = new ContextMenu({ category: "context", popupParent: this }));
                this.contextMenu.addProvider(this.model);
            },

            postCreate: function () {
                this.inherited(arguments);

                domClass.add(this.domNode, this.hierarchicalListClass);

                this._setupList();

              
            },

            startup: function () {
                this.inherited(arguments);

                this.model.startup();


                if (this.contextMenu) {
                    this.contextMenu.startup();
                }
            },

            destroy: function () {
                this.model.destroy();

                this.inherited(arguments);
            },

            layout: function () {
                 var containerSize = {
                        h: this._contentBox.h,
                        w: this._contentBox.w,
                        l: this._contentBox.l,
                        t: this._contentBox.t
                    };

                this.container.resize(containerSize);
            },

           

            _toggleActive: function (activeWidget) {
                // summary:
                //      Toggle visual indication between tree and list

                // var listActiveClass = "epi-list--is-active";
                // var treeActiveClass = "epi-tree--is-active";

                // if (activeWidget === this.tree) {
                //     domClass.replace(this.domNode, treeActiveClass, listActiveClass);
                // } else {
                //     domClass.replace(this.domNode, listActiveClass, treeActiveClass);
                // }
            },

            _showNotification: function (message) {
                // summary:
                //      Uses the alert dialog implementation to show notification with the supplied message
                //
                // message:
                //      html encoded string to show in notification dialog
                //
                // tags:
                //      public callback

                var dialog = new Alert({
                    destroyOnHide: true,
                    description: epistring.toHTML(message)
                });

                dialog.show();
            },

            _setupList: function () {
                // summary:
                //      Implementation should implement this, to setup the content list. For example, command binding.
                //
                // tags:
                //      protected
                var registry = this.model._commandRegistry;

                this.own(
                    aspect.after(this.list, "onFocus", function () {
                        this.model.updateListCommands();
                        this._toggleActive(this.list);
                    }.bind(this)),
                   
                    on(this.list, "selectionChanged", function (e) {
                        this.model.setSelectedListItems(e.selection);
                    }.bind(this)),
                    on(this.list.grid.domNode, "dgrid-refresh-complete", function () {
                        var selectedItems = this.get("selectedListItems");
                        this.list.grid.clearSelection();
                        if (selectedItems) {
                            selectedItems.forEach(function (item) {
                                this.list.grid.select(item.contentLink);
                            }, this);
                        }
                    }.bind(this))
                );


                if (this.model.changeContextOnItemSelection) {
                    var itemSelectAction = function () {
                        registry.edit.command.execute();
                    };
                    this.own(
                        on(this.list, "itemAction", itemSelectAction)
                    );
                }
                if (this.showThumbnail) {
                    domClass.add(this.list.grid.domNode, "epi-thumbnailContentList");
                }
                this.list.set("selectionMode", "extended");
            },
        });
    });
