﻿define("gl-translations/component/command/AddToNewJob", [
    "dojox/layout/ResizeHandle",
    "dojo/on",
    "dojo/_base/connect",
    "dojo/parser",
    "dojo/_base/lang",
    "epi/routes",
    "dojo/when",
    "dojo/topic",
    "epi/string",
    "dojo/_base/declare",
    "epi/shell/widget/dialog/Alert",
    "epi/dependency",
    "epi/shell/command/_Command",
    "epi/shell/TypeDescriptorManager",
    "epi-cms/legacy/LegacyDialogPopup",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/core/ContentReference",
    "epi/shell/ViewSettings",
    "epi/shell/socket/hub",
    "epi/shell/command/_SelectionCommandMixin",
    "epi-cms/_ContentContextMixin",
    "epi-cms/contentediting/ContentActionSupport"
],

    function (
        ResizeHandle, on,
        connect,
        parser,
        lang,
        routes,
        when,
        topic,
        epistring,
        declare,
        Alert,
        dependency,
        _Command,
        TypeDescriptorManager,
        LegacyDialogPopup,
        _HasChildDialogMixin,
        ContentReference,
        ViewSettings,
        hub,
        _SelectionCommandMixin,
        _ContentContextMixin,
        ContentActionSupport
    ) {

        return declare([_Command, _HasChildDialogMixin, _SelectionCommandMixin, _ContentContextMixin], {

            label: "Create job from current item",

            iconClass: "epi-iconPlus",
            projectJobId: null,
            currentContext: null,
            dataObject: null,
            constructor: function () {

            },

            setLabel: function (newLabel) {
                this.label = newLabel;
            },
            _execute: function () {

                this.currentContext = this._currentContext.id;
                this.store = this.store || dependency.resolve("epi.storeregistry").get("globallink.translationprojectstore");
                var promise = this.store.put({
                    "projectId": 0,
                    "contentId": this.currentContext,
                    "action": "addToNewJob"
                });
                var self = this;
                when(promise, function (value) {
                    console.log(value);
                    topic.publish("/epi/shell/context/request", {
                        uri: "epi.cms.contentdata:///" + value.contentLink
                    }, {
                            sender: this,
                            viewName: this.view,
                            forceContextChange: true,
                            forceReload: true
                        });
                }, function (error) {
                    var dialog = new Alert({
                        heading: "Cannot create new job",
                        destroyOnHide: true,
                        description: epistring.toHTML(error.xhr.statusText)
                    });
                    dialog.show();
                });
            },


            _onModelChange: function () {
            
                this.set("isAvailable", true);
                this.set("canExecute", this._currentContext);
            },
            
        });
    });
