"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var dashboard_service_1 = require("../../services/dashboard.service");
require("rxjs/add/observable/of");
require("rxjs/add/operator/do");
require("rxjs/add/operator/map");
require("rxjs/add/operator/delay");
var EmptyObservable_1 = require("rxjs/observable/EmptyObservable");
var DashboardComponent = /** @class */ (function () {
    function DashboardComponent(dashboardService, _changeDetectorRef) {
        var _this = this;
        this.dashboardService = dashboardService;
        this._changeDetectorRef = _changeDetectorRef;
        this.objectKeys = Object.keys;
        this.excludeFields = ["Id", "LanguageCode"];
        this.excludeFieldsDetail = ["Id", "LanguageCode", "SubmissionId", "Link", "AllowCancel"];
        this.nodes = [];
        this.headers = [
            //this.doSearchForMainList(this.jobStatus, this.lang, page, '', column, order);
            { title: 'Submission ID', field: 'SubmissionId', sort: 'esc', class: 'epi-grid--10' },
            { title: 'Job Name', field: 'Name', sort: '', class: 'epi-grid--45' },
            { title: 'Target Language', field: 'Language', sort: '', class: 'epi-grid--10' },
            { title: 'Status', field: 'Status', sort: '', class: 'epi-grid--10' },
            { title: 'Creator', field: 'Creator', sort: '', class: 'epi-grid--15' },
            { title: 'Created', field: 'CreatedDate', sort: 'esc', class: 'epi-grid--15' }
        ];
        this.headersDetail = [
            //{ title: 'Document Ticket', field: 'SubmissionId', sort: '', class: 'epi-grid--15' },
            { title: 'Content Name', field: 'Name', sort: '', class: 'epi-grid--35' },
            { title: 'Content ID', field: 'PageLink', sort: '', class: 'epi-grid--10' },
            { title: 'Content type', field: 'ContentType', sort: '', class: 'epi-grid--10' },
            { title: 'Target Language', field: 'Language', sort: '', class: 'epi-grid--10' },
            { title: 'Status', field: 'Status', sort: '', class: 'epi-grid--10' },
            { title: 'Translated', field: 'Translated', sort: '', class: 'epi-grid--12.5' },
            { title: 'Published', field: 'Published', sort: '', class: 'epi-grid--12.5' },
        ];
        this.defaultSortingMainIndex = 5; //By default on the main list will sort by SubmissionId DSC
        this.defaultSortingDetailIndex = 0; //By default on the main list will sort by SubmissionId ASC
        this.filter = '';
        this.gridTitle = 'Language Jobs';
        this.searchValue = '';
        this.searchValueJobs = '';
        this.searchAllChk = true;
        this.page = 1;
        this.pageSize = 10;
        this.isOpenTabJobs = false;
        this.isPinnedTab = false;
        this.detailMode = false;
        this.sort = '';
        this.name = '';
        this.orderedField = '';
        this.detailId = '';
        this.originalPathName = '';
        this.isDisableArchiveJobs = false;
        this.isDisableCancelJobs = true;
        this.isDisableResendJobs = true;
        this.isloading = false;
        this.archiveView = 'published';
        this.cancelView = ['myjobs', 'active'];
        this.statusShowArchiveCheckBox = ['published'];
        this.statusShowCancelCheckBox = ['Sent', 'WaitingToSend', 'Created', 'Error', 'ImportError', 'ExportError'];
        this.isShowArchiveCheckbox = false;
        this.isShowCancelCheckbox = true;
        this.isShowArchiveSelectedButton = false;
        this.isShowArchiveAllButton = false;
        this.isShowCancelSelectedButton = false;
        this.actionTypePaging = 'paging';
        this.isShowNoDta = false;
        this.numberOfSpanColumnNoData = 1;
        this.numberOfSpanColumnNoDataMainWithCheckBox = 7;
        this.numberOfSpanColumnNoDataDetail = 7;
        this.DoExcludeFields = function (element, index, array) {
            return _this.detailMode ? (!_this.excludeFieldsDetail.includes(element)) : (!_this.excludeFields.includes(element));
        };
        this.filterObjectKeys = function (obj) {
            var objKeys = Object.keys(obj);
            return objKeys
                .filter(function (k) { return !_this.excludeFields.includes(k); })
                .map(function (k) {
                var _a;
                return Object.assign({}, (_a = {}, _a[k] = obj[k], _a));
            })
                .reduce(function (res, o) { return Object.assign(res, o); }, {});
        };
        this.widthScreen = window.innerWidth;
        this.getSearchJobs = function (page, typeJob, language, jd, filter, column, order) {
            if (page === void 0) { page = 1; }
            if (typeJob === void 0) { typeJob = ''; }
            if (language === void 0) { language = ''; }
            if (jd === void 0) { jd = ''; }
            if (filter === void 0) { filter = ''; }
            if (column === void 0) { column = ''; }
            if (order === void 0) { order = ''; }
            var projId = _this.getUrlParameter('id');
            return {
                page: page,
                job: {
                    type: !_this.detailMode && _this.searchAllChk && filter != '' ? 'alljobs' : typeJob,
                    language: language
                },
                filter: filter,
                searchAll: _this.detailMode ? false : _this.searchAllChk,
                projectId: projId,
                id: _this.detailMode ? _this.detailId : jd !== '' ? jd : '',
                order: order,
                column: column
            };
        };
        this.selectNode = function (e) {
            var language = '';
            var type = '';
            if (e.node.data.name.includes('Jobs')) {
                type = e.node.data.code;
            }
            else {
                type = e.node.parent.data.code;
                language = e.node.data.code;
            }
            _this.lang = language;
            _this.searchAllChk = _this.filter != '' ? false : true;
            _this.jobStatus = type;
            _this.onClickJob({ type: type, language: language, filter: _this.filter });
        };
        this.replaceNode = function (nodes) {
            _this.nodes = nodes;
        };
        this.onSearch = function (job) {
            _this.loading = true;
            _this.gridTitle = 'The result for term: ' + job.filter;
            _this.realData = _this.dashboardService.onSelectJobObs(_this.getSearchJobs(1, job.type, job.language, '', job.filter))
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.loading = false;
            })
                .map(function (res) { return _this.formatRowFields(res.jobs); });
        };
        //todo
        this.getFilterJobs = function (page, typeJob, language, jd, filter, name, sort) {
            if (page === void 0) { page = 1; }
            if (typeJob === void 0) { typeJob = ''; }
            if (language === void 0) { language = ''; }
            if (jd === void 0) { jd = ''; }
            if (filter === void 0) { filter = ''; }
            if (name === void 0) { name = ''; }
            if (sort === void 0) { sort = ''; }
            var projId = _this.getUrlParameter('id');
            return {
                page: page,
                job: {
                    type: typeJob,
                    language: language
                },
                filter: filter,
                projectId: projId,
                id: _this.detailMode ? _this.detailId : jd !== '' ? jd : '',
                name: name,
                sort: sort
            };
        };
        //todo
        this.onFilterObsDes = function (job) {
            _this.loading = true;
            _this.realData = _this.dashboardService.onFilterObsDes(_this.getFilterJobs(1, job.type, job.language, '', job.filter, job.name, job.sort))
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.loading = false;
            })
                .map(function (res) { return _this.formatRowFields(res.jobs); });
        };
        this.onViewCloneSubmission = function () {
            //this.isloading = true;
            _this.dashboardService.onCloneSubmission(_this.detailId).then(function (res) {
                _this.isloading = false;
                if (res && res == "true") {
                    alert("Submission cloned");
                }
                else {
                    alert("Error cloning submission. Check log for details");
                }
            }).catch(function (err) {
                //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                _this.onLoadingArchiveJobAnimate(false);
                _this._changeDetectorRef.detectChanges();
                console.log(err);
                _this.isloading = false;
            });
        };
        this.onViewCancelTargets = function () {
            var selectedItem = _this.getIdFromCheckedCancelItem();
            _this.dashboardService.onCancelTarget(selectedItem).then(function (res) {
                if (res) {
                    //refresh page;
                    window.location.reload(true);
                }
                else {
                    //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                    _this.onLoadingArchiveJobAnimate(false);
                    _this._changeDetectorRef.detectChanges();
                }
            }).catch(function (err) {
                //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                _this.onLoadingArchiveJobAnimate(false);
                _this._changeDetectorRef.detectChanges();
                console.log(err);
            });
        };
        this.onViewCancelJobs = function () {
            var selectedItem = '';
            selectedItem = _this.getIdFromCheckedArchiveItem();
            if (confirm("Are you sure you want to proceed with cancellation? You may have already been quoted for this submission, please contact your TDC representative for details")) {
                _this.dashboardService.onCancelJob(selectedItem).then(function (res) {
                    if (res) {
                        //refresh page;
                        //window.location.reload(true);
                        alert("Selected jobs will be cancelled in background");
                    }
                    else {
                        //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                        _this.onLoadingArchiveJobAnimate(false);
                        _this._changeDetectorRef.detectChanges();
                    }
                }).catch(function (err) {
                    //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                    _this.onLoadingArchiveJobAnimate(false);
                    _this._changeDetectorRef.detectChanges();
                    console.log(err);
                });
            }
        };
        this.onViewResendJobs = function () {
            var selectedItem = '';
            selectedItem = _this.getIdFromCheckedArchiveItem();
            if (confirm("Are you sure you want to resend selected jobs? Only Waiting/Error jobs will be resent. You may have already been quoted for this submission, please contact your TDC representative for details")) {
                _this.dashboardService.onResend(selectedItem).then(function (res) {
                    if (res) {
                        //refresh page;
                        //window.location.reload(true);
                        alert("Selected Waiting/Error jobs will be resent in background");
                    }
                    else {
                        //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                        _this.onLoadingArchiveJobAnimate(false);
                        _this._changeDetectorRef.detectChanges();
                    }
                }).catch(function (err) {
                    //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                    _this.onLoadingArchiveJobAnimate(false);
                    _this._changeDetectorRef.detectChanges();
                    console.log(err);
                });
            }
        };
        this.onViewArchiveJobs = function (isArchiveAll) {
            if (isArchiveAll === void 0) { isArchiveAll = false; }
            var selectedItem = '';
            if (!isArchiveAll) {
                selectedItem = _this.getIdFromCheckedArchiveItem();
            }
            _this.dashboardService.onArchiveJob(_this.lang, selectedItem, isArchiveAll).then(function (res) {
                if (res) {
                    //refresh page;
                    window.location.reload(true);
                }
                else {
                    //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                    _this.onLoadingArchiveJobAnimate(false);
                    _this._changeDetectorRef.detectChanges();
                }
            }).catch(function (err) {
                //show log and handle status variable isloading and isDisableArchiveJobs is false for button archive jobs.
                _this.onLoadingArchiveJobAnimate(false);
                _this._changeDetectorRef.detectChanges();
                console.log(err);
            });
        };
        //todo
        this.onFilterObsEsc = function (job) {
            _this.loading = true;
            _this.realData = _this.dashboardService.onFilterObsEsc(_this.getFilterJobs(1, job.type, job.language, '', job.filter, job.name, job.sort))
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.loading = false;
            })
                .map(function (res) { return _this.formatRowFields(res.jobs); });
        };
        this.onClickJob = function (job) {
            _this.resetValueForArchivedItems(job.type);
            _this.resetValueForCancelItems();
            //if user is in detail and do searching, will clear filter before selecting job by node
            if (_this.detailMode) {
                _this.searchValueJobs = _this.filter;
                _this.filter = '';
                _this.searchValue = '';
            }
            _this.detailMode = false;
            _this.detailId = '';
            var jd = _this.getUrlParameter('jd');
            if (jd !== undefined && jd !== '') {
                //if current url contains jd of job's detail, need to remove this part and set again url
                window.history.pushState({}, document.title, _this.originalPathName);
            }
            // this.jobStatus, this.lang, page, this.filter, column, order);
            var page = 1, column = _this.headers[_this.defaultSortingMainIndex].field, order = 'dsc';
            _this.defaultSort(false);
            _this.doSearchForMainList(job.type, job.language, page, _this.filter, column, order);
        };
        this.formatRowFields = function (dataRows) {
            var result = [];
            for (var _i = 0, dataRows_1 = dataRows; _i < dataRows_1.length; _i++) {
                var dataRow = dataRows_1[_i];
                var formated = {
                    Id: dataRow.Id,
                    SubmissionId: dataRow.SubmissionId,
                    Name: dataRow.Name,
                    Language: dataRow.Language,
                    Status: dataRow.Status,
                    Creator: dataRow.Creator,
                    Created: dataRow.Created,
                    LanguageCode: dataRow.LanguageCode
                };
                result.push(formated);
            }
            return result;
        };
        this.formatRowFieldsDetail = function (dataRows) {
            var result = [];
            for (var _i = 0, dataRows_2 = dataRows; _i < dataRows_2.length; _i++) {
                var dataRow = dataRows_2[_i];
                var formated = {
                    Id: dataRow.Id,
                    Name: dataRow.Name,
                    Link: dataRow.PageUrl,
                    PageLink: dataRow.PageLink,
                    AllowCancel: dataRow.AllowCancel,
                    SubmissionId: dataRow.SubmissionId,
                    ContentType: dataRow.ContentType,
                    Language: dataRow.Language,
                    Status: dataRow.Status,
                    TranslatedString: dataRow.TranslatedString,
                    PublishedString: dataRow.PublishedString
                };
                result.push(formated);
            }
            return result;
        };
        this.doSearchForMainList = function (jobStatus, language, page, filter, column, order, actionType) {
            if (column === void 0) { column = ''; }
            if (order === void 0) { order = ''; }
            if (actionType === void 0) { actionType = ''; }
            _this.loading = true;
            _this.gridTitle = filter !== '' ? 'The result for term: ' + filter : "Language Jobs";
            _this.isShowNoDta = false;
            _this.realData = _this.dashboardService.onSelectJobObs(_this.getSearchJobs(page, jobStatus, language, '', filter, column, order))
                .do(function (res) {
                _this.currentJobs = res.jobs;
                _this.isDisableArchiveJobs = res.jobs.length === 0 ? true : false;
                _this.isDisableCancelJobs = true;
                _this.isDisableResendJobs = true;
                _this.total = res.total;
                _this.page = res.page;
                _this.pageSize = res.pageSize;
                _this.loading = false;
                //Determine show checkbox or not
                if (_this.isShowArchiveCheckbox || _this.isShowCancelCheckbox) {
                    var checked = false;
                    for (var i = 0; i < _this.currentJobs.length; i++) {
                        var updateItem = { "Id": _this.currentJobs[i].Id, language: _this.currentJobs[i].LanguageCode, status: _this.currentJobs[i].Status, "checked": checked };
                        var existedItem = _this.getExistedCheckedArchivedItem(updateItem);
                        if (existedItem != null) {
                            checked = existedItem.checked;
                        }
                        else {
                            _this.updateCurrenCheckedArchiveItem(updateItem, false);
                        }
                        _this.arArchivedItem.push(checked);
                    }
                }
                //set number of span column
                if (res.jobs.length <= 0) {
                    _this.isShowNoDta = true;
                    _this.numberOfSpanColumnNoData = _this.isShowArchiveCheckbox ? _this.numberOfSpanColumnNoDataMainWithCheckBox : _this.numberOfSpanColumnNoDataMainWithCheckBox - 1;
                }
            })
                .map(function (res) { return _this.formatRowFields(res.jobs); });
        };
        this.doSearchForDetailJob = function (page, jobDetailId, filter, column, order, jobName) {
            if (column === void 0) { column = ''; }
            if (order === void 0) { order = ''; }
            if (jobName === void 0) { jobName = ''; }
            _this.loading = true;
            _this.isShowNoDta = false;
            var title = filter !== '' ? 'The result for term: ' + filter : jobName;
            if (title !== '') {
                _this.gridTitle = title;
            }
            var searchJob = _this.getSearchJobs(page, _this.jobStatus, '', jobDetailId, filter, column, order);
            _this.realData = _this.dashboardService.goDetailObs(searchJob)
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.pageSize = res.pageSize;
                _this.loading = false;
                if (title === '' && res.term !== undefined) {
                    _this.gridTitle = res.term;
                }
                for (var i = 0; i < res.jobDetail.length; i++) {
                    res.jobDetail[i].AllowCancel = _this.statusShowCancelCheckBox.indexOf(res.jobDetail[i].Status) >= 0 ? 'true' : 'false';
                    console.log("test " + res.jobDetail[i].Name + ":" + res.jobDetail[i].AllowCancel + ":" + res.jobDetail[i].Status);
                }
                if (res.jobDetail.length <= 0) {
                    _this.isShowNoDta = true;
                    _this.numberOfSpanColumnNoData = _this.numberOfSpanColumnNoDataDetail;
                }
            })
                .map(function (res) { return _this.formatRowFieldsDetail(res.jobDetail); });
        };
        this.goDetail = function (row) {
            if (!_this.detailMode || (row.isPagingInDetailMode !== undefined && row.isPagingInDetailMode)) {
                _this.defaultSort(true);
                _this.searchValueJobs = _this.filter;
                _this.filter = '';
                _this.searchValue = '';
                _this.realData = new EmptyObservable_1.EmptyObservable();
                _this.detailMode = true;
                _this.loading = true;
                _this.detailId = row.Id !== undefined ? row.Id : '';
                _this.page = row.page !== undefined ? row.page : 0;
                var filter = '', column = _this.headersDetail[_this.defaultSortingDetailIndex].field, order = 'esc';
                _this.doSearchForDetailJob(_this.page, _this.detailId, filter, column, order, row.Name);
                //update url to show "jd" part when is in detail mode
                var jd = _this.getUrlParameter('jd');
                if (jd === '') {
                    window.history.pushState({}, document.title, _this.originalPathName + '?jd=' + _this.detailId);
                }
                //clear order info
                _this.sort = '';
                _this.name = '';
                _this.orderedField = '';
            }
        };
        // todo
        this.goFilterDetailDes = function (detailJobs) {
            _this.realData = new EmptyObservable_1.EmptyObservable();
            _this.loading = true;
            var searchDetailJob = _this.getFilterJobs(1, detailJobs.type, detailJobs.language, _this.detailId, detailJobs.filter, detailJobs.name, detailJobs.sort);
            _this.gridTitle = detailJobs.Name;
            _this.realData = _this.dashboardService.onFilterDetailObsDes(searchDetailJob)
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.pageSize = res.pageSize,
                    _this.loading = false;
            })
                .map(function (res) { return _this.formatRowFieldsDetail(res.jobDetail); });
            //update url to show "jd" part when is in detail mode
            var jd = _this.getUrlParameter('jd');
            if (jd === '') {
                window.history.pushState({}, document.title, _this.originalPathName + '?jd=' + _this.detailId);
            }
        };
        // todo
        this.goFilterDetailEsc = function (detailJobs) {
            _this.realData = new EmptyObservable_1.EmptyObservable();
            _this.loading = true;
            var searchDetailJob = _this.getFilterJobs(1, detailJobs.type, detailJobs.language, detailJobs.detailId, detailJobs.filter, detailJobs.name, detailJobs.sort);
            _this.gridTitle = detailJobs.Name;
            _this.realData = _this.dashboardService.onFilterDetailObsEsc(searchDetailJob)
                .do(function (res) {
                _this.total = res.total;
                _this.page = res.page;
                _this.pageSize = res.pageSize,
                    _this.loading = false;
            })
                .map(function (res) { return _this.formatRowFieldsDetail(res.jobDetail); });
            //update url to show "jd" part when is in detail mode
            var jd = _this.getUrlParameter('jd');
            if (jd === '') {
                window.history.pushState({}, document.title, _this.originalPathName + '?jd=' + _this.detailId);
            }
        };
        this.goBack = function () {
            _this.resetValueForArchivedItems(_this.jobStatus);
            _this.resetValueForCancelItems(_this.jobStatus);
            _this.defaultSort(false);
            _this.detailMode = false;
            _this.detailId = '';
            _this.filter = _this.searchValueJobs;
            _this.searchValue = _this.searchValueJobs;
            _this.gridTitle = 'Language Jobs';
            _this.getPage(1);
            var jd = _this.getUrlParameter('jd');
            if (jd !== undefined && jd !== '') {
                //if current url contains jd of job's detail, need to remove this part and set again url
                window.history.pushState({}, document.title, _this.originalPathName);
            }
        };
        this.openJobTab = function () {
            if (!_this.isPinnedTab) {
                _this.isOpenTabJobs = !_this.isOpenTabJobs;
            }
        };
        this.pinTab = function () {
            _this.isPinnedTab = !_this.isPinnedTab;
        };
    }
    DashboardComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.resetValueForArchivedItems();
        this.resetValueForCancelItems();
        var projId = this.getUrlParameter('id');
        var jd = this.getUrlParameter('jd');
        this.originalPathName = location.pathname;
        //Search on detail job items
        if (jd !== undefined && jd !== '') {
            this.goDetail({ Id: jd, ID: jd, page: 0 });
        }
        //search on main list
        else {
            var page = 1, column = '', order = '';
            //by default will sort  by SubmissionId DESC
            this.onHandleSort(this.headers[this.defaultSortingMainIndex], this.defaultSortingMainIndex, false);
        }
        this.dashboardService.getTreeMenu().then(function (res) {
            _this.replaceNode(res);
        }).catch(function (err) {
            console.error(err);
        });
    };
    DashboardComponent.prototype.onArchivedItemCheck = function ($event, index) {
        var checkbox = $event.target;
        var Id = checkbox.value;
        var language = checkbox.dataset.language;
        if (this.arArchivedItem != null && this.arArchivedItem.length - 1 >= index) {
            this.arArchivedItem[index] = $event.target.checked;
        }
        this.updateCurrenCheckedArchiveItem({ "Id": Id, language: language, "checked": checkbox.checked });
        this.checkNumberofCheckedArchiveItem();
        this.checkNumberofCheckedCancelJobItem();
        this.checkNumberofCheckedResendJobItem();
    };
    DashboardComponent.prototype.onCancelItemCheck = function ($event, index) {
        this.checkNumberofCheckedCancelItem();
    };
    DashboardComponent.prototype.onCancelAllItemCheck = function ($event, index) {
        var nodes = document.querySelectorAll(".cancelItemCheck");
        for (var i = 0; i < nodes.length; i++) {
            var input = nodes[i];
            input.checked = $event.target.checked;
        }
        this.checkNumberofCheckedCancelItem();
    };
    DashboardComponent.prototype.updateCurrenCheckedArchiveItem = function (updatedItem, isNeedToFind) {
        if (isNeedToFind === void 0) { isNeedToFind = true; }
        var isFound = false;
        if (isNeedToFind) {
            for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
                var archivedItem = this.arCurrentCheckedArchivedItem[i];
                if (archivedItem.Id == updatedItem.Id && archivedItem.language == updatedItem.language) {
                    archivedItem.checked = updatedItem.checked;
                    isFound = true;
                    break;
                }
            }
        }
        if (!isFound) {
            this.arCurrentCheckedArchivedItem.push({ "Id": updatedItem.Id, language: updatedItem.language, "status": updatedItem.status, "checked": updatedItem.checked });
        }
    };
    DashboardComponent.prototype.updateCurrenCheckedCancelItem = function (updatedItem, isNeedToFind) {
        if (isNeedToFind === void 0) { isNeedToFind = true; }
        var isFound = false;
        if (isNeedToFind) {
            for (var i = 0; i < this.arCurrentCheckedCancelItem.length; i++) {
                var cancelItem = this.arCurrentCheckedCancelItem[i];
                if (cancelItem.Id == updatedItem.Id) {
                    cancelItem.checked = updatedItem.checked;
                    isFound = true;
                    break;
                }
            }
        }
        if (!isFound) {
            this.arCurrentCheckedCancelItem.push({ "Id": updatedItem.Id, "checked": updatedItem.checked });
        }
    };
    DashboardComponent.prototype.getExistedCheckedArchivedItem = function (item) {
        for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
            var archivedItem = this.arCurrentCheckedArchivedItem[i];
            if (archivedItem.Id == item.Id && archivedItem.language == item.language) {
                return archivedItem;
            }
        }
        return null;
    };
    DashboardComponent.prototype.getExistedCheckedCancelItem = function (item) {
        for (var i = 0; i < this.arCurrentCheckedCancelItem.length; i++) {
            var cancelItem = this.arCurrentCheckedCancelItem[i];
            if (cancelItem.Id == item.Id) {
                return cancelItem;
            }
        }
        return null;
    };
    DashboardComponent.prototype.setValueForArrayArchivedItem = function (value) {
        if (this.arArchivedItem != null) {
            for (var i = 0; i < this.arArchivedItem.length; i++) {
                this.arArchivedItem[i] = value;
            }
        }
    };
    DashboardComponent.prototype.setValueForArrayCancelItem = function (value) {
        if (this.arCancelItem != null) {
            for (var i = 0; i < this.arCancelItem.length; i++) {
                this.arCancelItem[i] = value;
            }
        }
    };
    DashboardComponent.prototype.checkNumberofCheckedCancelJobItem = function () {
        var numberOfCheckedItems = 0;
        this.isDisableCancelJobs = true;
        for (var i = 0; i < this.arArchivedItem.length; i++) {
            numberOfCheckedItems += this.arArchivedItem[i] ? 1 : 0;
        }
        if (numberOfCheckedItems > 0) {
            for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
                if (this.arCurrentCheckedArchivedItem[i].checked) {
                    if (this.arCurrentCheckedArchivedItem[i].status == 'Sent' || this.arCurrentCheckedArchivedItem[i].status == 'WaitingToSend' || this.arCurrentCheckedArchivedItem[i].status == 'Created'
                        || this.arCurrentCheckedArchivedItem[i].status == 'Sending' || this.arCurrentCheckedArchivedItem[i].status == 'SentAhead' || this.arCurrentCheckedArchivedItem[i].status == 'Error'
                        || this.arCurrentCheckedArchivedItem[i].status == 'ImportError' || this.arCurrentCheckedArchivedItem[i].status == 'ExportError') {
                        this.isDisableCancelJobs = false;
                        break;
                    }
                }
            }
        }
    };
    DashboardComponent.prototype.checkNumberofCheckedResendJobItem = function () {
        var numberOfCheckedItems = 0;
        this.isDisableResendJobs = true;
        for (var i = 0; i < this.arArchivedItem.length; i++) {
            numberOfCheckedItems += this.arArchivedItem[i] ? 1 : 0;
        }
        if (numberOfCheckedItems > 0) {
            for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
                if (this.arCurrentCheckedArchivedItem[i].checked) {
                    if (this.arCurrentCheckedArchivedItem[i].status == 'WaitingToSend' || this.arCurrentCheckedArchivedItem[i].status == 'Created'
                        || this.arCurrentCheckedArchivedItem[i].status == 'Sending' || this.arCurrentCheckedArchivedItem[i].status == 'SentAhead' || this.arCurrentCheckedArchivedItem[i].status == 'Error'
                        || this.arCurrentCheckedArchivedItem[i].status == 'ExportError') {
                        this.isDisableResendJobs = false;
                        break;
                    }
                }
            }
        }
    };
    DashboardComponent.prototype.checkNumberofCheckedArchiveItem = function () {
        var numberOfCheckedItems = 0;
        this.isShowArchiveSelectedButton = false;
        for (var i = 0; i < this.arArchivedItem.length; i++) {
            numberOfCheckedItems += this.arArchivedItem[i] ? 1 : 0;
        }
        var showButton = numberOfCheckedItems > 0;
        if (!showButton) {
            for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
                if (this.arCurrentCheckedArchivedItem[i].checked) {
                    showButton = this.arCurrentCheckedArchivedItem[i].checked;
                    break;
                }
            }
        }
        this.isShowArchiveSelectedButton = showButton;
    };
    DashboardComponent.prototype.checkNumberofCheckedCancelItem = function () {
        this.isShowCancelSelectedButton = this.getIdFromCheckedCancelItem().length > 1;
    };
    DashboardComponent.prototype.resetValueForCancelItems = function (status) {
        if (status === void 0) { status = ''; }
        this.isShowCancelSelectedButton = false;
    };
    DashboardComponent.prototype.resetValueForArchivedItems = function (jobType) {
        if (jobType === void 0) { jobType = ''; }
        this.isShowArchiveCheckbox = this.isInArchiveCheckboxStatus(jobType);
        this.arArchivedItem = [];
        this.arCurrentCheckedArchivedItem = [];
        this.isShowArchiveSelectedButton = false;
        this.isShowArchiveAllButton = this.isShowArchiveCheckbox;
    };
    DashboardComponent.prototype.getIdFromCheckedArchiveItem = function () {
        var ids = '';
        var nodes = document.querySelectorAll(".archiveItemCheck");
        var arCheckedArchiveItem = new Array();
        for (var i = 0; i < nodes.length; i++) {
            var input = nodes[i];
            if (input.checked) {
                arCheckedArchiveItem.push({ "Id": input.value, language: input.dataset.language });
            }
        }
        for (var i = 0; i < this.arCurrentCheckedArchivedItem.length; i++) {
            var archivedItem = this.arCurrentCheckedArchivedItem[i];
            var isExisted = false;
            for (var j = 0; j < arCheckedArchiveItem.length; j++) {
                if (archivedItem.Id == arCheckedArchiveItem[j].Id
                    && archivedItem.language == arCheckedArchiveItem[j].language) {
                    isExisted = true;
                    break;
                }
            }
            if (!isExisted && archivedItem.checked) {
                arCheckedArchiveItem.push({ "Id": archivedItem.Id, language: archivedItem.language });
            }
        }
        for (var i = 0; i < arCheckedArchiveItem.length; i++) {
            var language = this.lang === undefined || this.lang === '' || this.lang.length <= 0 ? ';' + arCheckedArchiveItem[i].language : '';
            ids += arCheckedArchiveItem[i].Id.toString() + language + ',';
        }
        return ids;
    };
    DashboardComponent.prototype.getIdFromCheckedCancelItem = function () {
        var ids = '';
        var nodes = document.querySelectorAll(".cancelItemCheck");
        for (var i = 0; i < nodes.length; i++) {
            var input = nodes[i];
            if (input.checked) {
                ids += input.value + ',';
            }
        }
        return ids;
    };
    DashboardComponent.prototype.isInArchiveCheckboxStatus = function (status) {
        return status !== undefined && status.length > 0 && this.statusShowArchiveCheckBox.indexOf(status) >= 0;
    };
    DashboardComponent.prototype.isInCancelCheckboxStatus = function (status) {
        return status !== undefined && status.length > 0 && this.statusShowCancelCheckBox.indexOf(status) >= 0;
    };
    DashboardComponent.prototype.getPage = function (page) {
        this.loading = true;
        if (this.detailMode && this.detailId !== '') {
            this.doSearchForDetailJob(page, this.detailId, this.filter, this.orderedField, this.sort, this.gridTitle);
            return;
        }
        this.arArchivedItem = [];
        this.arCancelItem = [];
        this.doSearchForMainList(this.jobStatus, this.lang, page, this.filter, this.orderedField, this.sort, this.actionTypePaging);
    };
    DashboardComponent.prototype.getUrlParameter = function (name) {
        name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
        var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
        var results = regex.exec(location.search);
        return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
    };
    DashboardComponent.prototype.onSearchConfirm = function (event) {
        if (this.detailMode) {
            var jd = this.getUrlParameter('jd');
            var filter = event.target.value;
            this.doSearchForDetailJob(1, this.detailId, this.filter, this.orderedField, this.sort);
        }
        else {
            //this.onSearch({ type: this.jobStatus, language: this.lang, filter: this.filter });
            var page = 1, column = this.orderedField, order = this.sort;
            this.doSearchForMainList(this.jobStatus, this.lang, page, this.filter, column, order);
        }
    };
    DashboardComponent.prototype.onSearchChange = function (event) {
        var filter = event.target.value;
        this.filter = event.target.value;
        if (event.keyCode === 13) {
            this.onSearchConfirm(event);
        }
    };
    DashboardComponent.prototype.onSearchAllChange = function (event) {
        if (!this.detailMode && this.filter != '') {
            var page = 1, column = this.orderedField, order = this.sort;
            this.doSearchForMainList(this.jobStatus, this.lang, page, this.filter, column, order);
        }
    };
    DashboardComponent.prototype.onLoadingArchiveJobAnimate = function (status) {
        this.isloading = status;
        this.isDisableArchiveJobs = status;
    };
    DashboardComponent.prototype.defaultSort = function (isDetail) {
        this.headers.map(function (val) { return val.sort = ''; });
        this.headersDetail.map(function (val) { return val.sort = ''; });
        if (isDetail) {
            this.headersDetail[this.defaultSortingDetailIndex].sort = 'esc';
            this.orderedField = this.headersDetail[this.defaultSortingDetailIndex].field;
            this.sort = 'dsc';
        }
        else {
            this.headers[this.defaultSortingMainIndex].sort = 'dsc';
            this.orderedField = this.headers[this.defaultSortingMainIndex].field;
            this.sort = 'dsc';
        }
    };
    DashboardComponent.prototype.onHandleSort = function (header, index, detail) {
        if (detail) {
            this.headersDetail.map(function (val, i) { return index !== i ? val.sort = '' : val.sort = header.sort; });
            if (header.sort === '' || header.sort === 'dsc') {
                header.sort = 'esc';
            }
            else {
                header.sort = 'dsc';
            }
            this.doSearchForDetailJob(this.page, this.detailId, this.filter, header.field, header.sort);
        }
        else {
            this.headers.map(function (val, i) { return index !== i ? val.sort = '' : val.sort = header.sort; });
            if (header.sort === '' || header.sort === 'dsc') {
                header.sort = 'esc';
            }
            else {
                header.sort = 'dsc';
            }
            //when go to detail page => need to clear order info?
            this.doSearchForMainList(this.jobStatus, this.lang, this.page, this.filter, header.field, header.sort);
        }
        this.sort = header.sort;
        this.name = header.title;
        this.orderedField = header.field;
    };
    DashboardComponent.prototype.handleClearSearchBox = function () {
        this.searchValue = '';
        //trigger event search with customized object paramater, filter will be empty
        this.onSearchChange({
            target: { value: '', },
            keyCode: 13
        });
    };
    DashboardComponent = __decorate([
        core_1.Component({
            selector: 'dashboard',
            templateUrl: './dashboard.component.html',
            styleUrls: ['./dashboard.component.scss'],
            changeDetection: core_1.ChangeDetectionStrategy.OnPush
        }),
        __metadata("design:paramtypes", [dashboard_service_1.DashboardService, core_1.ChangeDetectorRef])
    ], DashboardComponent);
    return DashboardComponent;
}());
exports.DashboardComponent = DashboardComponent;
//# sourceMappingURL=dashboard.component.js.map