"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var api_url_1 = require("./api.url");
var http_client_1 = require("../common/shared/http-client");
require("rxjs/add/operator/toPromise");
var DashboardService = /** @class */ (function () {
    function DashboardService(httpClient) {
        this.httpClient = httpClient;
        this.shuffleArray = function (array) {
            var _a;
            var arr = array.map(function (x) { return x; });
            for (var i = arr.length - 1; i > 0; i--) {
                var j = Math.floor(Math.random() * (i + 1));
                _a = [arr[j], arr[i]], arr[i] = _a[0], arr[j] = _a[1]; // eslint-disable-line no-param-reassign
            }
            return arr;
        };
    }
    DashboardService.prototype.allKeysToUpperCase = function (obj) {
        var output = {};
        for (var i in obj) {
            var key = i.charAt(0).toUpperCase() + i.slice(1);
            if (Object.prototype.toString.apply(obj[i]) === '[object Object]') {
                output[key] = this.allKeysToUpperCase(obj[i]);
            }
            else {
                if (Array.isArray(obj[i])) {
                    var arr = [];
                    for (var j = 0; j < obj[i].length; j++) {
                        var item = this.allKeysToUpperCase(obj[i][j]);
                        arr.push(item);
                    }
                    output[key] = arr;
                }
                else {
                    output[key] = obj[i];
                }
            }
        }
        return output;
    };
    DashboardService.prototype.getJobs = function (projId) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/jobs';
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            return _this.allKeysToUpperCase(res.json());
        });
    };
    DashboardService.prototype.getTreeMenu = function () {
        var url = api_url_1.API.DashboardApiURL + '/treeMenu';
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            return res.json();
        });
    };
    DashboardService.prototype.onSelectJobObs = function (searchJobs) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/filterJobs/?lang=' + searchJobs.job.language + '&status=' + searchJobs.job.type + '&page=' + searchJobs.page + '&filter=' + searchJobs.filter + '&searchAll=' + searchJobs.searchAll + '&column=' + searchJobs.column + '&order=' + searchJobs.order;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var result = jsonResult.Jobs;
            var tresult = {
                jobs: result.filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                total: jsonResult.Total,
                pageSize: jsonResult.PageSize
            };
            return tresult;
        });
    };
    DashboardService.prototype.onSearchObs = function (searchJobs) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/filterJobs/?lang=' + searchJobs.job.language + '&status=' + searchJobs.job.type + '&page=' + searchJobs.page;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var tresult = {
                jobs: jsonResult.Jobs.filter(function (row) { return row.Name.includes(searchJobs.filter); }).filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                pageSize: jsonResult.PageSize,
                total: jsonResult.Total
            };
            return tresult;
        });
    };
    DashboardService.prototype.onFilterObsDes = function (filterJob) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + "/filterJobsDes/?lang=" + filterJob.job.language + "&status=" + filterJob.job.type + "&page=" + filterJob.page + "&filter=" + filterJob.filter + "&name=" + filterJob.name + "&sort=" + filterJob.sort;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var result = jsonResult.Jobs;
            var tresult = {
                jobs: result.filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                total: jsonResult.Total,
                pageSize: jsonResult.PageSize
            };
            return tresult;
        });
    };
    DashboardService.prototype.onFilterObsEsc = function (filterJob) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + "/filterJobsEsc/?lang=" + filterJob.job.language + "&status=" + filterJob.job.type + "&page=" + filterJob.page + "&filter=" + filterJob.filter + "&name=" + filterJob.name + "&sort=" + filterJob.sort;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var tresult = {
                jobs: jsonResult.Jobs.filter(function (row) { return row.Name.includes(filterJob.filter); }).filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                pageSize: jsonResult.PageSize,
                total: jsonResult.Total
            };
            return tresult;
        });
    };
    DashboardService.prototype.onFilterDetailObsDes = function (filterDetailJob) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + "/jobs/detailDes/" + filterDetailJob.id + "?page=" + filterDetailJob.page + "&filter=" + filterDetailJob.filter + "&name=" + filterDetailJob.name + "&sort=" + filterDetailJob.sort;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var result = jsonResult.Jobs;
            var tresult = {
                jobDetail: jsonResult.JobItemDetails.filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                total: jsonResult.Total,
                pageSize: jsonResult.PageSize
            };
            return tresult;
        });
    };
    DashboardService.prototype.onFilterDetailObsEsc = function (filterDetailJob) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + "/jobs/detailEsc/" + filterDetailJob.id + "?page=" + filterDetailJob.page + "&filter=" + filterDetailJob.filter + "&name=" + filterDetailJob.name + "&sort=" + filterDetailJob.sort;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var tresult = {
                jobDetail: jsonResult.JobItemDetails.filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                pageSize: jsonResult.PageSize,
                total: jsonResult.Total
            };
            return tresult;
        });
    };
    DashboardService.prototype.goDetailObs = function (searchJobs) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/jobDetail/?id=' + searchJobs.id + "&status=" + searchJobs.job.type + "&page=" + searchJobs.page + "&filter=" + searchJobs.filter + "&column=" + searchJobs.column + "&order=" + searchJobs.order;
        return this.httpClient.get(url).map(function (res) {
            var jsonResult = _this.allKeysToUpperCase(res.json());
            var tresult = {
                jobDetail: jsonResult.JobItemDetails.filter(function (x, i) { return i < jsonResult.PageSize; }),
                page: jsonResult.Page,
                pageSize: jsonResult.PageSize,
                total: jsonResult.Total,
                term: jsonResult.Name
            };
            return tresult;
        });
    };
    DashboardService.prototype.onPage = function (searchJobs) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/filterJobs/?lang=' + searchJobs.job.language + '&status=' + searchJobs.job.type + '&page=' + searchJobs.page + '&filter=' + searchJobs.filter;
        return this.httpClient.get(url).map(function (res) {
            return _this.allKeysToUpperCase(res.json());
        });
    };
    DashboardService.prototype.onArchiveJob = function (lang, ids, isArchiveAll) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/jobsArchive?lang=' + lang + "&ids=" + ids + "&isArchiveAll=" + isArchiveAll;
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            var result = _this.allKeysToUpperCase(res.json());
            return result;
        });
    };
    DashboardService.prototype.onCancelJob = function (ids) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/jobsCancel?ids=' + ids;
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            var result = _this.allKeysToUpperCase(res.json());
            return result;
        });
    };
    DashboardService.prototype.onResend = function (ids) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/resend?ids=' + ids;
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            var result = _this.allKeysToUpperCase(res.json());
            return result;
        });
    };
    DashboardService.prototype.onCancelTarget = function (ids) {
        var _this = this;
        var url = api_url_1.API.DashboardApiURL + '/targetsCancel?ids=' + ids;
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            var result = _this.allKeysToUpperCase(res.json());
            return result;
        });
    };
    DashboardService.prototype.onCloneSubmission = function (ids) {
        var url = api_url_1.API.DashboardApiURL + '/cloneSubmission?id=' + ids;
        return this.httpClient.get(url).toPromise().catch().then(function (res) {
            return res.text();
        });
    };
    DashboardService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_client_1.HttpClient])
    ], DashboardService);
    return DashboardService;
}());
exports.DashboardService = DashboardService;
//# sourceMappingURL=dashboard.service.js.map