"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var angular_tree_component_1 = require("angular-tree-component");
var translation_service_1 = require("../../services/translation.service");
var TranslationComponent = /** @class */ (function () {
    function TranslationComponent(translationService) {
        var _this = this;
        this.translationService = translationService;
        this.widthRefer = 400;
        this.translations = {
            SourceLocale: { Name: '', Value: false, Field: '' },
            TargetLocales: [], Name: '', PD: '', PostAction: '',
            DueDate: '', JobSettings: [], ContentSettings: [], PostActions: [], LoadTree: true
        };
        this.actionSelected = "";
        this.isLoading = false;
        this.isLoadingPopup = false;
        this.isLoadingItems = true;
        this.loadingText = "Loading text";
        this.selectedContentText = "Selected content";
        this.referencedContentText = "Referenced Content";
        this.isAllRefChecked = false;
        this.isAllRefVisible = false;
        this.isRefDisabled = false;
        this.excludeItems = [];
        this.includeItems = [];
        this.settings = [];
        this.needRefresh = false;
        this.today = Date.now();
        this.postAction = ['None', 'Auto Publish', 'Set status as Ready for Publish', 'Create EPiServer Project For Approval'];
        this.totalNodes = 0;
        this.uncheckedNodes = 0;
        this.projId = '';
        this.onEvent = function ($event) { return $event.treeModel.expandAll(); };
        this.convertToSetting = function (commonSetting) {
            var setting = {
                Field: commonSetting.Field,
                Value: commonSetting.Value,
                Name: commonSetting.Name
            };
            return setting;
        };
        this.options = {
            getChildren: this.getChildren.bind(this),
        };
        this.nodes = [];
        this.refItems = [];
        this.currentNodesSearch = [];
        this.asyncChildren = [
            {
                name: 'child1',
                type: 'doc',
                hasChildren: true,
                checked: false,
            },
            {
                name: 'child2',
                type: 'file',
                checked: true,
            }
        ];
        this.onSearchTree = function (text) {
            console.log('On searching');
        };
        this.determineCheckAndUncheckedNodes = function () {
            _this.totalNodes = 0;
            _this.uncheckedNodes = 0;
            _this.excludeItems = [];
            //Calculating nodes for "Selected content" tree
            for (var i_1 = 0; i_1 < _this.nodes.length; i_1++) {
                _this.getChildrenNode(_this.nodes[i_1]);
            }
            //Calculating nodes for "Referenced Content" list        
            //let totalItemReferenceContent = this.refItems.length;
            //let totalItemReferenceContentChecked = this.refItems.filter(x => !x.checked).length;
            for (var i = 0; i < _this.refItems.length; i++) {
                _this.getChildrenRefNode(_this.refItems[i]);
            }
            //this.totalNodes += totalItemReferenceContent;
            //this.uncheckedNodes += totalItemReferenceContentChecked;
        };
        this.onSubmit = function () {
            _this.isLoading = true;
            console.log('On submit');
            var projId = _this.getUrlParameter('id');
            if (_this.projId !== '' && _this.projId !== projId) {
                projId = _this.projId;
            }
            var confirmMessageEvent = document.createEvent("CustomEvent");
            _this.determineCheckAndUncheckedNodes();
            if (_this.totalNodes > 0 && _this.totalNodes == _this.uncheckedNodes) {
                _this.isLoading = false;
                confirmMessageEvent.initCustomEvent('showConfirmMessageForTranslationJob', false, false, { description: "Please select at least one item for translation." });
                window.dispatchEvent(confirmMessageEvent);
                return;
            }
            _this.translationService.createSubmission(projId, _this.excludeItems).then(function (res) {
                console.log(res);
                setTimeout(function () {
                    _this.isLoading = false;
                    if (res) {
                        var event = document.createEvent('Event');
                        event.initEvent('submitTranslation', true, true);
                        window.dispatchEvent(event);
                        confirmMessageEvent.initCustomEvent('showConfirmDialogForTranslationJob', false, false, { description: "Your job is being sent for translation, you will receive a notification when done.<br><br>Open Submission Dashboard to keep track of the status" });
                    }
                    else {
                        confirmMessageEvent.initCustomEvent('showConfirmMessageForTranslationJob', false, false, { description: "Translation Job could not be sent." });
                    }
                    window.dispatchEvent(confirmMessageEvent);
                }, 1000);
            }).catch(function (err) {
                confirmMessageEvent.initCustomEvent('showConfirmMessageForTranslationJob', false, false, { description: "Translation Job could not be sent." });
                window.dispatchEvent(confirmMessageEvent);
                _this.isLoading = false;
                console.error(err);
            });
        };
        this.replaceNode = function (nodes) {
            _this.nodes = nodes;
            _this.currentNodesSearch = nodes;
        };
        this.updateRefPages = function (node, $event) {
            var checked = !node.data.checked;
            _this.updateCheckedItems(node.data, checked);
            node.data.checked = checked;
            _this.setAllRefChecked();
        };
        this.check = function (node, $event) {
            _this.updateChildNodesCheckBox(node, $event.target.checked);
            _this.updateParentNodesCheckBox(node.parent);
        };
        this.updateCheckedItems = function (node, checked) {
            if (node.checked) {
                if (!checked) {
                    var exist = _this.excludeItems.some(function (x) { return x == node.id; });
                    if (!exist) {
                        _this.excludeItems.push(node.id);
                    }
                }
            }
            else {
                if (checked) {
                    var index = _this.excludeItems.indexOf(node.id, 0);
                    if (index > -1) {
                        _this.excludeItems.splice(index, 1);
                    }
                }
            }
        };
        this.updateChildNodesCheckBox = function (node, checked) {
            _this.updateCheckedItems(node.data, checked);
            node.data.checked = checked;
            if (node.children) {
                node.children.forEach(function (child) { return _this.updateChildNodesCheckBox(child, checked); });
            }
        };
        this.updateParentNodesCheckBox = function (node) {
            if (node && node.level > 0 && node.children) {
                var allChildChecked = true;
                var noChildChecked = true;
                for (var _i = 0, _a = node.children; _i < _a.length; _i++) {
                    var child = _a[_i];
                    if (!child.data.checked) {
                        allChildChecked = false;
                    }
                    else if (child.data.checked) {
                        noChildChecked = false;
                    }
                }
                if (allChildChecked) {
                    node.data.checked = true;
                    node.data.indeterminate = false;
                }
                else if (noChildChecked) {
                    //node.data.checked = false;
                    //node.data.indeterminate = false;
                }
                else {
                    node.data.checked = true;
                    node.data.indeterminate = true;
                }
                _this.updateParentNodesCheckBox(node.parent);
            }
        };
        this.onPostActionChanged = function (pAction) {
            var projId = _this.getUrlParameter('id');
            _this.translationService.updatePostAction(projId, pAction).then(function (res) {
                console.log("Change post action to: " + pAction + " message: " + res);
            }).catch(function (err) {
                console.error(err);
            });
        };
        this.onClickSetting = function (setting) {
            _this.needRefresh = true;
            var settingIndex = _this.settings.findIndex(function (x) { return x.Field == setting.Field; });
            if (settingIndex == -1) {
                _this.settings.push(setting);
            }
            else {
                _this.settings[settingIndex].Value = setting.Value;
            }
            if (setting.Field == 'IncludeReferencedContent') {
                _this.isRefDisabled = setting.Value;
            }
        };
        this.onClickAllRefs = function (node, $event) {
            _this.setAllRefChecked();
            for (var i = 0; i < _this.refItems.length; i++) {
                _this.onClickAllRefsChild(_this.refItems[i], _this.isAllRefChecked);
            }
            _this.setAllRefChecked();
        };
        this.getListTarget = function (arrayString) {
            return arrayString.map(function (x) { return x.Code; }).join(', ');
        };
        this.onLoadItems = function (e) {
            e.preventDefault();
            _this.isLoadingPopup = false;
            _this.isLoadingItems = true;
            var projId = _this.getUrlParameter('id');
            if (_this.projId !== '' && _this.projId !== projId) {
                projId = _this.projId;
            }
            _this.translationService.getTreeModel(projId).then(function (res) {
                if (res.status == 0 || res.status == 1) {
                    _this.checkTreeInterval = setInterval(_this.checkTree, 5000, _this);
                }
                else {
                    _this.excludeItems = res.excludedItems;
                    _this.refItems = res.refItems;
                    _this.setAllRefChecked();
                    _this.replaceNode(res.nodeItems);
                    _this.isLoadingItems = false;
                }
            }).catch(function (err) {
                _this.isLoadingItems = false;
                console.error(err);
            });
        };
        this.setAllRefChecked = function () {
            _this.isAllRefChecked = true;
            if (_this.refItems.length <= 0) {
                _this.isAllRefVisible = false;
            }
            else {
                for (var i = 0; i < _this.refItems.length; i++) {
                    _this.setAllRefCheckedChild(_this.refItems[i]);
                    if (!_this.isAllRefChecked) {
                        break;
                    }
                }
                _this.isAllRefVisible = true;
            }
        };
        this.onRefreshTree = function (e) {
            e.preventDefault();
            _this.needRefresh = false;
            _this.isLoadingPopup = false;
            _this.isLoadingItems = true;
            var projId = _this.getUrlParameter('id');
            if (_this.projId !== '' && _this.projId !== projId) {
                projId = _this.projId;
            }
            _this.translationService.updateSettings(projId, _this.settings).then(function (res) {
                if (res.status == 0 || res.status == 1) {
                    _this.checkTreeInterval = setInterval(_this.checkTree, 5000, _this);
                }
                else {
                    _this.isLoadingItems = false;
                }
                _this.excludeItems = res.excludedItems;
                _this.refItems = res.refItems;
                _this.setAllRefChecked();
                _this.replaceNode(res.nodeItems);
            }).catch(function (err) {
                _this.isLoadingItems = false;
                console.error(err);
            });
        };
        this.changeExcluded = function (ref, e) {
            ref.isExcluded = !ref.isExcluded;
            console.log(ref);
        };
        this.isTree = false;
        this.isWraper = false;
        this.widthWraper = 400;
        this.x = 300;
        this.y = 100;
        this.px = 0;
        this.py = 0;
        this.height = 300;
        this.draggingCorner = false;
        this.draggingWindow = false;
        this.minArea = 20000;
        this.projId = '';
    }
    TranslationComponent.prototype.ngOnInit = function () {
        var _this = this;
        var width = jQuery('html', window.parent.document).width() * 88 / 100;
        this.widthWraper = width * 0.29;
        this.widthRefer = width * 0.35;
        var projId = this.getUrlParameter('id');
        this.projId = projId;
        this.isLoadingPopup = false;
        this.isLoadingItems = true;
        this.translationService.getTranslations(projId).then(function (res) {
            _this.translations = res;
            _this.actionSelected = _this.translations.PostAction;
            var setting = _this.translations.ContentSettings.find(function (s) { return s.Field == 'IncludeReferencedContent'; });
            if (setting) {
                _this.isRefDisabled = !setting.Value;
            }
            if (res.LoadTree) {
                _this.isLoadingPopup = false;
                _this.isLoadingItems = true;
                _this.translationService.getTreeModel(projId).then(function (res) {
                    if (res.status == 0 || res.status == 1) {
                        _this.loadingText = "Loading again " + res.status;
                        _this.checkTreeInterval = setInterval(_this.checkTree, 5000, _this);
                    }
                    else {
                        _this.excludeItems = res.excludedItems;
                        _this.refItems = res.refItems;
                        _this.setAllRefChecked();
                        _this.replaceNode(res.nodeItems);
                        _this.isLoadingItems = false;
                    }
                }).catch(function (err) {
                    _this.isLoadingItems = false;
                    console.error(err);
                });
            }
            else {
                _this.isLoadingPopup = true;
                _this.isLoadingItems = false;
            }
        }).catch(function (err) {
            console.error(err);
        });
    };
    TranslationComponent.prototype.checkTree = function (obj) {
        obj.translationService.checkTreeModel(obj.projId).then(function (res) {
            if (res.status == 0 || res.status == 1) {
            }
            else {
                clearInterval(obj.checkTreeInterval);
                obj.excludeItems = res.excludedItems;
                obj.refItems = res.refItems;
                obj.replaceNode(res.nodeItems);
                obj.treeComponent.treeModel.expandAll();
                obj.treerefComponent.treeModel.expandAll();
                obj.setAllRefChecked();
                obj.isLoadingItems = false;
            }
            obj.selectedContentText = "Selected content (" + (obj.countTreeItems(res.nodeItems) - 1) + ")";
            obj.referencedContentText = "Referenced Content (" + (obj.countTreeItems(res.refItems)) + ")";
        }).catch(function (err) {
            obj.isLoadingItems = false;
            console.error(err);
        });
    };
    TranslationComponent.prototype.countTreeItems = function (data) {
        var len = data.length;
        if (len > 0) {
            for (var i = 0; i < data.length; i++) {
                if (data[i].children && data[i].children.length > 0) {
                    len = len + this.countTreeItems(data[i].children);
                }
            }
        }
        return len;
    };
    TranslationComponent.prototype.initialized = function (tree) {
        tree.treeModel.expandAll();
    };
    TranslationComponent.prototype.onUpdateData = function ($event) {
        $event.treeModel.expandAll();
    };
    TranslationComponent.prototype.onUpdateDataRef = function ($event) {
        $event.treeModel.expandAll();
    };
    ;
    TranslationComponent.prototype.ngAfterViewInit = function () {
        var width = jQuery('html', window.parent.document).width() * 88 / 100;
        var heightIframe = parseInt(jQuery('.dijitDialogPaneContentArea > div > iframe', window.parent.document).css('height').split('px')[0]);
        if (width < 1500) {
            jQuery('.dijitDialogPaneContentArea > div > iframe', window.parent.document).css('height', heightIframe * 1.09 + 'px');
        }
        else {
            jQuery('.dijitDialogPaneContentArea > div > iframe', window.parent.document).css('height', heightIframe * 1.1 + 'px');
        }
        jQuery('html').css('height', '100%');
        jQuery('body').css('height', '96%');
        jQuery('form').css('height', '100%');
        if (navigator.userAgent.indexOf("Firefox") != -1) {
            if (width < 1500) {
                jQuery('.f-content').css({ "height": "76% !important", "max-height": "75%" });
            }
            else {
                jQuery('.f-content').css({ "height": "80% !important", "max-height": "80%" });
            }
        }
    };
    TranslationComponent.prototype.ngAfterContentChecked = function () { };
    TranslationComponent.prototype.loadDefaultSettings = function () {
        var _this = this;
        this.settings = [];
        var projSettings = this.translations.ContentSettings.map(function (x) { return _this.convertToSetting(x); }).concat(this.translations.JobSettings.map(function (y) { return _this.convertToSetting(y); }));
        this.settings = projSettings;
    };
    TranslationComponent.prototype.getUrlParameter = function (name) {
        name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
        var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
        var results = regex.exec(location.search);
        return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
    };
    TranslationComponent.prototype.getChildren = function (node) {
        var newNodes = this.asyncChildren.map(function (c) { return Object.assign({}, c); });
        return new Promise(function (resolve, reject) {
            setTimeout(function () { return resolve(newNodes); }, 1000);
        });
    };
    TranslationComponent.prototype.getChildrenRefNode = function (parentNode) {
        this.totalNodes++;
        if (!parentNode.checked) {
            this.uncheckedNodes++;
            if (this.excludeItems.indexOf(parentNode.id) < 0) {
                this.excludeItems.push(parentNode.id);
            }
        }
        if (parentNode.children != undefined && parentNode.children.length > 0) {
            var children = parentNode.children;
            for (var i = 0; i < children.length; i++) {
                this.getChildrenRefNode(children[i]);
            }
        }
    };
    TranslationComponent.prototype.getChildrenNode = function (parentNode) {
        this.totalNodes++;
        if (!parentNode.checked) {
            this.uncheckedNodes++;
            //if current node isn't the root node of tree (Pages, Blocks, Products...)
            if (this.translationService.rootNodeIds.indexOf(parentNode.id) < 0 && this.excludeItems.indexOf(parentNode.id) < 0) {
                this.excludeItems.push(parentNode.id);
            }
        }
        if (parentNode.children != undefined && parentNode.children.length > 0) {
            var children = parentNode.children;
            for (var i = 0; i < children.length; i++) {
                this.getChildrenNode(children[i]);
            }
        }
    };
    TranslationComponent.prototype.onClickAllRefsChild = function (parentNode, checked) {
        if (checked) {
            var exist = this.excludeItems.some(function (x) { return x == parentNode.id; });
            if (!exist) {
                this.excludeItems.push(parentNode.id);
            }
            parentNode.checked = false;
        }
        else {
            var index = this.excludeItems.indexOf(parentNode.id, 0);
            if (index > -1) {
                this.excludeItems.splice(index, 1);
            }
            parentNode.checked = !parentNode.isDisabled && true;
        }
        if (parentNode.children != undefined && parentNode.children.length > 0) {
            var children = parentNode.children;
            for (var i = 0; i < children.length; i++) {
                this.onClickAllRefsChild(children[i], checked);
            }
        }
    };
    TranslationComponent.prototype.setAllRefCheckedChild = function (parentNode) {
        if (!parentNode.isDisabled && !parentNode.checked) {
            this.isAllRefChecked = false;
        }
        else {
            if (parentNode.children != undefined && parentNode.children.length > 0) {
                var children = parentNode.children;
                for (var i = 0; i < children.length; i++) {
                    this.setAllRefCheckedChild(children[i]);
                    if (!this.isAllRefChecked) {
                        break;
                    }
                }
            }
        }
    };
    TranslationComponent.prototype.area = function () {
        return this.width * this.height;
    };
    TranslationComponent.prototype.bottomRightResize = function (offsetX, offsetY) {
        this.isTree = true;
        this.isWraper = false;
        this.width += offsetX;
    };
    TranslationComponent.prototype.bottomRightResizeWraper = function (offsetX, offsetY) {
        this.isWraper = true;
        this.isTree = false;
        this.widthWraper += offsetX;
    };
    TranslationComponent.prototype.onCornerClick = function (event, resizer) {
        this.draggingCorner = true;
        this.px = event.clientX;
        this.py = event.clientY;
        this.resizer = resizer;
        event.preventDefault();
        event.stopPropagation();
    };
    TranslationComponent.prototype.onCornerMove = function (event) {
        if (!this.draggingCorner) {
            return;
        }
        var offsetX = event.clientX - this.px;
        var offsetY = event.clientY - this.py;
        var lastX = this.x;
        var lastY = this.y;
        var pWidth = this.width;
        var pHeight = this.height;
        this.resizer(offsetX, offsetY);
        this.px = event.clientX;
        this.py = event.clientY;
    };
    TranslationComponent.prototype.onCornerRelease = function (event) {
        this.draggingWindow = false;
        this.draggingCorner = false;
    };
    __decorate([
        core_1.ViewChild('tree'),
        __metadata("design:type", angular_tree_component_1.TreeComponent)
    ], TranslationComponent.prototype, "treeComponent", void 0);
    __decorate([
        core_1.ViewChild('treeref'),
        __metadata("design:type", angular_tree_component_1.TreeComponent)
    ], TranslationComponent.prototype, "treerefComponent", void 0);
    __decorate([
        core_1.HostListener('document:mousemove', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [MouseEvent]),
        __metadata("design:returntype", void 0)
    ], TranslationComponent.prototype, "onCornerMove", null);
    __decorate([
        core_1.HostListener('document:mouseup', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [MouseEvent]),
        __metadata("design:returntype", void 0)
    ], TranslationComponent.prototype, "onCornerRelease", null);
    TranslationComponent = __decorate([
        core_1.Component({
            selector: 'translation',
            templateUrl: './translation.component.html',
            styleUrls: ['./translation.component.scss']
        }),
        __metadata("design:paramtypes", [translation_service_1.TranslationService])
    ], TranslationComponent);
    return TranslationComponent;
}());
exports.TranslationComponent = TranslationComponent;
//# sourceMappingURL=translation.component.js.map