"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
var api_url_1 = require("./api.url");
// import {}
var AuthenticationService = /** @class */ (function () {
    function AuthenticationService(http) {
        this.http = http;
    }
    AuthenticationService.prototype.login = function (loginModel) {
        var data = {
            username: loginModel.username,
            password: loginModel.password,
            grant_type: "password",
            scope: "openid offline_access tt.pms.Api",
            client_id: 'ro.client',
            client_secret: 'secret'
        };
        var headers = new http_1.Headers();
        headers.append("Authorization", "Basic " + btoa(data.client_id + ":" + data.client_secret));
        headers.append("Content-Type", "application/x-www-form-urlencoded");
        var body = "";
        for (var key in data) {
            if (body.length) {
                body += "&";
            }
            body += key + "=";
            body += encodeURIComponent(data[key]);
        }
        this.http.post(api_url_1.API.Login, body, { headers: headers })
            .subscribe(function (response) {
            if (response.status == 200) {
                var user = response.json();
                if (user && user.access_token) {
                    localStorage.setItem('access_token', JSON.stringify({
                        key: "Bearer " + user.access_token
                    }));
                    localStorage.setItem("isLoggin", "true");
                    window.location.href = "/home";
                }
                else {
                    return "";
                }
            }
            else {
                return "";
            }
        }, function (error) {
            return "";
        });
    };
    AuthenticationService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http])
    ], AuthenticationService);
    return AuthenticationService;
}());
exports.AuthenticationService = AuthenticationService;
//# sourceMappingURL=authentication.service.js.map