"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var targetLocales = [
    // { Title: 'English', IsChecked: true },
    { Name: 'German', Value: true, Field: 'TargetLocale_1' },
    { Name: 'Swedish', Value: false, Field: 'TargetLocale_2' },
    { Name: 'Rusian', Value: false, Field: 'TargetLocale_3' },
];
var SourceLocale = { Name: 'German', Value: true, Field: 'SourceLocale' };
var contentSettings = [
    { Name: 'Include Child Nodes', Value: true, Field: 'IncludeChildren' },
    { Name: 'Include Parent', Value: false, Field: 'IncludeParent' },
    { Name: 'Include Referenced Content', Value: false, Field: 'IncludeReferenced' },
    { Name: 'Include product variations', Value: true, Field: 'IncludeProduct' },
    { Name: 'Include expired source', Value: false, Field: 'IncludeExpired' },
];
var jobSettings = [
    { Name: 'Exclude expired target', Value: true, Field: 'ExcludeExpiredTarget' },
    { Name: 'Exclude unchanged content', Value: false, Field: 'ExcludeUnchangedContent' },
    { Name: 'Exclude content if similar task exists', Value: true, Field: 'ExcludeContentIfSimilar' },
    { Name: 'AutoPublish', Value: false, Field: 'AutoPublish' },
];
var postActions = [
    { Name: 'None', Value: 'NONE' },
    { Name: 'Set status as Ready for Publish', Value: 'PROJECT_READY_TO_PUBLISH' },
    { Name: 'Auto Publish', Value: 'AUTO_PUBLISH' },
    { Name: 'Create EPiServer Project For Approval', Value: 'PROJECT_APPROVAL' }
];
exports.translations = {
    Name: 'Projekt 15',
    PD: '',
    DueDate: '',
    TargetLocales: targetLocales,
    SourceLocale: SourceLocale,
    ContentSettings: contentSettings,
    JobSettings: jobSettings,
    PostActions: postActions,
    PostAction: '',
    LoadTree: true
};
exports.treeModel = [
    {
        name: 'Pages',
        type: 'page',
        checked: true,
        children: [
            {
                name: 'Page 1',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 1',
                        type: 'block',
                        checked: true,
                    },
                    {
                        name: 'Block 2',
                        type: 'block',
                        checked: true,
                    },
                    {
                        name: 'Page 14',
                        type: 'page',
                        checked: true,
                        children: [
                            {
                                name: 'Block 6',
                                type: 'block',
                                checked: true,
                            }
                        ]
                    }
                ]
            },
            {
                name: 'Page 2',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 3',
                        type: 'block',
                        checked: true
                    }
                ]
            }
        ]
    },
    {
        name: 'Referenced Pages',
        type: 'page',
        checked: true,
        children: [
            {
                name: 'Page 3',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 7',
                        type: 'block',
                        checked: true,
                    }
                ]
            }
        ]
    },
    {
        name: 'Blocks',
        type: 'block',
        checked: true,
        children: [
            {
                name: 'Block 4',
                type: 'block',
                checked: true,
            },
            {
                name: 'Block 5',
                type: 'block',
                checked: true,
            }
        ]
    },
    {
        name: 'Catalog',
        type: 'catalog',
        checked: true,
        children: [
            {
                name: 'Product 1',
                type: 'product',
                checked: true,
                children: [
                    {
                        name: 'Product Variant',
                        type: 'product',
                        checked: true,
                    }
                ]
            }
        ]
    }
];
exports.treeModelLocale = [
    {
        name: 'Pages',
        type: 'page',
        checked: true,
        children: [
            {
                name: 'Page 1',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 1',
                        type: 'page',
                        checked: true,
                    },
                    {
                        name: 'Block 2',
                        type: 'block',
                        checked: true,
                    },
                    {
                        name: 'Page 14',
                        type: 'page',
                        checked: true,
                        children: [
                            {
                                name: 'Block 6',
                                type: 'block',
                                checked: true,
                            }
                        ]
                    }
                ]
            },
            {
                name: 'Page 2',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 3',
                        type: 'block',
                        checked: true
                    }
                ]
            }
        ]
    }
];
exports.treeModelUpdateSetting = [
    {
        name: 'Pages',
        type: 'page',
        checked: true,
        children: [
            {
                name: 'Page 1',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 1',
                        type: 'block',
                        checked: true,
                    },
                    {
                        name: 'Block 2',
                        type: 'block',
                        checked: true,
                    },
                    {
                        name: 'Page 14',
                        type: 'page',
                        checked: true,
                        children: [
                            {
                                name: 'Block 6',
                                type: 'block',
                                checked: true,
                            }
                        ]
                    }
                ]
            },
            {
                name: 'Page 2',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 3',
                        type: 'block',
                        checked: true
                    }
                ]
            }
        ]
    },
    {
        name: 'Referenced Pages',
        type: 'page',
        checked: true,
        children: [
            {
                name: 'Page 3',
                type: 'page',
                checked: true,
                children: [
                    {
                        name: 'Block 7',
                        type: 'block',
                        checked: true,
                    }
                ]
            }
        ]
    },
    {
        name: 'Blocks',
        type: 'block',
        checked: true,
        children: [
            {
                name: 'Block 4',
                type: 'block',
                checked: true,
            },
            {
                name: 'Block 5',
                type: 'block',
                checked: true,
            }
        ]
    },
    {
        name: 'Catalog',
        type: 'catalog',
        checked: true,
        children: [
            {
                name: 'Product 1',
                type: 'product',
                checked: true,
                children: [
                    {
                        name: 'Product Variant',
                        type: 'product',
                        checked: true,
                    }
                ]
            }
        ]
    }
];
//# sourceMappingURL=mockData.js.map