﻿define("gl-translations/component/ReferencesEditor", [

        // Dojo
        "dojo/_base/array",
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/dom-construct",
        "dojo/on",
        "dojox/html/entities",

        // Dijit
    "dijit/focus",
    "dojo/when",
        "dijit/_TemplatedMixin",
        "dijit/_Widget",
        "dijit/form/CheckBox",
        "dijit/form/TextBox",
    "dijit/form/Select",
    "dijit/form/Button",
    "epi/shell/widget/dialog/Alert",
        "dojo/store/Memory",
        "dojo/data/ObjectStore",

        // EPi
    "epi/shell/widget/_ValueRequiredMixin",
    "epi-cms/_ContentContextMixin",
    "epi/dependency",
    ], function (

        // Dojo
        array,
        declare,
        lang,
        domConstruct,
        on,
        entities,

        // Dijit
        focusUtil,
        when,
        _TemplatedMixin,
        _Widget,
        CheckBox,
        TextBox,
        
        ComboBox,
        Button,
        Alert,
        Memory,
        ObjectStore,

        // EPi
        _ValueRequiredMixin,
        _ContentContextMixin,
        dependency
    ) {

        return declare([_Widget, _TemplatedMixin, _ValueRequiredMixin, _ContentContextMixin,], {
                // tags:
                //      internal

                templateString: "<div class=\"dijit dijitReset dijitInline\"></div>",

                baseClass: "epi-checkBoxList",

                valueIsCsv: true,

            valueIsInclusive: true,

                value: null,

                store: null,

                input: null,

                constructor: function () {
                    this._checkboxes = [];
                    this._labelClickHandles = [];
                },

                buildRendering: function () {
                    this.inherited(arguments);

                    //array.forEach(this.selections, this._addCheckBoxForItem, this);
                },

                destroy: function () {
                    var checkbox;
                    while ((checkbox = this._checkboxes.pop())) {
                        checkbox.destroyRecursive();
                    }

                    var labelClickHandle;
                    while ((labelClickHandle = this._labelClickHandles.pop())) {
                        labelClickHandle.remove();
                    }

                    this.inherited(arguments);
                },

                focus: function () {
                    // summary:
                    //		Focus the widget.

                },

                onChange: function (/*===== newValue =====*/) {
                    // summary:
                    //		Callback when this widget's value is changed.
                    // tags:
                    //		callback
                },

                onBlur: function () {
                    // summary:
                    //		Callback when this widget loses focus.
                    // tags:
                    //		callback
                },

                onFocus: function () {
                    // summary:
                    //		Callback when this widget gains focus.
                    // tags:
                    //		callback
                },

                _calculateValue: function () {
                    alert("calculateVal");
                },

            _setValueAttr: function (value) {
                
                    this._set("value", value);

                    this.value = value;

                var json = JSON.parse(value);
                    domConstruct.empty(this.domNode);
                    this._addTextBoxForItem();
                array.forEach(json, function (selection) {
                        this._addLabelForItem(selection);
                    }, this);
                    

                },

                _onBlur: function () {
                    this.inherited(arguments);
                    this.onBlur();
                },

                _addLabelForItem: function (item) {
                    // Create a container for the label and checkbox.
                    var container = domConstruct.create("div", { "class": "dijitTreeLabel", "style": "border: 1px solid #CCC;padding: 5px 10px;cursor: default;" }, this.domNode);

                    var label = domConstruct.create("label", {  }, container);
                    label.textContent = item.Name + " (" + item.ContentReference + ") ";
                    var label2 = domConstruct.create("label", { "class": "dijitTreeLabel2", "style": "float:right;cursor: pointer;"}, container);
                    label2.textContent = "x";
                    label2.dataset.id = item.ContentReference;
                    var self = this;
                    on(label2, "click", lang.hitch(label2, function () {
                        if (confirm("Are you sure you want to remove item from submission?")){
                            self.store = self.store || dependency.resolve("epi.storeregistry").get("globallink.translationprojectstore");
                            var promise = self.store.put({
                                "projectId": self._currentContext.id,
                                "contentId": this.dataset.id,
                                "action": "removeFromJobUi"
                            });
                            
                            when(promise, function (value) {
                                self.set("value", value);
                            }, function (error) {
                                var dialog = new Alert({
                                    heading: "Cannot remove from job",
                                    destroyOnHide: true,
                                    description: epistring.toHTML(error.xhr.statusText)
                                });
                                dialog.show();
                            });
                        }
                    }));
                    //label.placeAt(container);
                    this._checkboxes.push(label);

                },
                //epi-card-list
                _addTextBoxForItem: function () {
                    // Create a container for the label and checkbox.
                    var container = domConstruct.create("div", { "class": "dijitInputField dijitInputContainer epi-form-container__section__row", "style":"padding:0" }, this.domNode);

                    // Add the checkbox to the container.
                    this.input = new TextBox({ value: "", name: "new_ref", placeHolder:"Content ID" });
                    this.input.placeAt(container);

                    var button = new Button({ name: "add_new_ref", title: "Add reference", label: "Add reference"});
                    button.placeAt(container);
                    this._labelClickHandles.push(on(button, "click", lang.hitch(this, function () {
                        this.store = this.store || dependency.resolve("epi.storeregistry").get("globallink.translationprojectstore");
                        var promise = this.store.put({
                            "projectId": this._currentContext.id,
                            "contentId": this.input.value,
                            "action": "addToJobUi"
                        });
                        var self = this;
                        when(promise, function (value) {
                            console.log(value);
                            self.set("value", value);
                        }, function (error) {
                            var dialog = new Alert({
                                heading: "Cannot add to job",
                                destroyOnHide: true,
                                description: error.xhr.statusText
                            });
                            dialog.show();
                        });
                    })));

                },
                _setFilterAttr: function (filter) {
                    alert("setFilter");
                },

                _setSelectionsAttr: function (selections) {
                    this.set("value", this.value);
                },


            });
        });
