define("gl-translations/component/SharedBlocks", [
// dojo
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/aspect",
    "dojo/dom-construct",
    "dojo/dom-geometry",
    "dojo/dom-class",

    "dojo/on",
    // epi
    "gl-translations/asset/HierarchicalList",
    "gl-translations/component/SharedBlocksViewModel"
],

function (
// dojo
    array,
    declare,
    lang,
    aspect,
    domConstruct,
    domGeometry,
    domClass,
    on,
    // epi
    HierarchicalList,
    SharedBlocksViewModel) {

    return declare([HierarchicalList], {
        // summary:
        //      Shared blocks component
        // tags:
        //      internal

        modelClassName: SharedBlocksViewModel,

        noDataMessages: { multiple: "These root does not contain any jobs", single: "This root does not contain any jobs" },

        // hierarchicalListClass: [readonly] String
        //      The CSS class to be used on the content list.
        hierarchicalListClass: "epi-blockList",

        // createContentIcon: [public] String
        //      The icon class to be used in the create content area of the list.
        createContentIcon: "epi-iconPlus",

        // createContentText: [public] String
        createContentText: "New Job",

        postMixInProperties: function () {
            this.inherited(arguments);
            this.modelBindingMap.showAllLanguages = ["showAllLanguages"];
        },

        buildRendering: function () {
            this.inherited(arguments);
            this.bottomLinkContainer = domConstruct.toDom("<div class=\"epi-gadget-bottom-container dijitHidden\"></div>");
            domConstruct.place(this.bottomLinkContainer, this.domNode);
        },

        layout: function () {
             var   containerSize = {
                    h: this._contentBox.h,
                    w: this._contentBox.w,
                    l: this._contentBox.l,
                    t: this._contentBox.t
                };

            this.container.resize(containerSize);
        },

        // =======================================================================
        // List setup

        _setupList: function () {
            this.inherited(arguments);

            var registry = this.model._commandRegistry,
                listWidget = this.list;

            this.own(
                on(listWidget, "delete", function () {
                    registry["delete"].command.execute();
                })
            );
        },
    });
});