﻿define("gl-translations/component/SharedBlocksViewModel", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    // epi
    "../asset/view-model/HierarchicalListViewModel",
    "epi-cms/component/_ShowAllLanguagesMixin",

    // command
    "./command/NewBlock"
],

function (
// dojo
    declare,
    lang,
    when,
    // epi
    HierarchicalListViewModel,
    _ShowAllLanguagesMixin,

    // command
    NewBlockCommand
) {

    return declare([HierarchicalListViewModel, _ShowAllLanguagesMixin], {
        // summary:
        //      Handles search and tree to list browsing widgets.
        // tags:
        //      internal
         _selectedTreeItemsSetter: function (selectedItems) {
             // summary:
             //      Update model of commands in case selected content is folder
             // tags:
             //      private

             //The default upload command should only update when the list is updated.
             //It needs to be updated before the pseudocommanddecorator is applied.
             this._commandRegistry.newBlockDefault.command.set("model", selectedItems);

             this.inherited(arguments);
         },

        _setupCommands: function () {
            // summary:
            //      Creates and registers the commands used.
            // tags:
            //      protected
            console.log('_setupCommands');
            this.inherited(arguments);

            var customCommands = {
                newBlockDefault: {
                    command: new NewBlockCommand({
                        viewModel: this
                    })
                }
            };

            this._commandRegistry = lang.mixin(this._commandRegistry, customCommands);
            this.pseudoContextualCommands.push(this._commandRegistry.newBlockDefault.command);
        },
    });
});
