﻿define([
    "dojo",
    "epi/_Module",
    "epi/dependency",
    "epi/routes",
    "gl-translations/Component/TranslationToolButtonProvider",
    "dojo/_base/lang",
    // CMS
    "epi-cms/project/viewmodels/ProjectModeToolbarViewModel",
    "gl-translations/component/command/TranslateProject",
    "epi-cms/project/command/AddProject",
    "epi-cms/project/command/RenameProject",
    "epi-cms/project/command/RemoveProject"
], function (
    dojo,
    _Module,
    dependency,
    routes,
    TranslationButtonCommandProvider,
    lang,
    ProjectModeToolbarViewModel,
    TranslateProject,
    AddProject,
    RenameProject,
    RemoveProject
) {
    return dojo.declare([_Module], {
        initialize: function () {
            this.inherited(arguments);
            // Do any custom module initialization here

            var commandregistry = dependency.resolve("epi.globalcommandregistry");
            commandregistry.registerProvider("epi.cms.contentdetailsmenu", new TranslationButtonCommandProvider({
                plugInArea: "toolButton"
            }));

            var registry = this.resolveDependency("epi.storeregistry");

            // Register store
            // /EPiServer/GlobalLink.Translation/stores/translateproject
            var restpath = this._getRestPath("translateproject");
            registry.create("globallink.translationprojectstore", restpath);

            this._overrideProjectModeToolbarViewModel();
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "GlobalLink.Translation", storeName: name });
        },
        _overrideProjectModeToolbarViewModel: function () {
            lang.extend(ProjectModeToolbarViewModel, {
                _createCommands: function () {
                    var commandArgs = {
                        model: this,
                        category: "context",
                        propertiesToWatch: ["currentProject"]
                    },
                        commands = this.own(
                            new TranslateProject(commandArgs),
                            new AddProject(commandArgs),
                            new RenameProject(commandArgs),
                            new RemoveProject(commandArgs)
                        );

                    this.set("commands", commands);
                    
                }
            });
        }
    });
    });
 